<?xml version="1.0" encoding="ISO-8859-1" ?>
<?rscvt type="out-filter" version="1.0" name="MoniMetor CSV (.csv)" file-ext="*.csv;" cmd-ext="mon_out" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://ww.w3.org/TR/xlink" version="1.0">
	<!-- Ausgabe-Deklarationen -->
	<xsl:output method="text" encoding="ISO-8859-1"/>
	<xsl:strip-space elements="*"/>
	<xsl:decimal-format name="european" decimal-separator="," grouping-separator="."/>

	<xsl:template name="ReadPolygons">
		<xsl:param name="x_offset"/>
		<xsl:param name="y_offset"/>
		<xsl:param name="z_offset"/>
		<xsl:param name="SensorID"/>

		<xsl:if test="$SensorID &lt; 10">
			<xsl:for-each select="polygon">
				<xsl:for-each select="point">
					<xsl:if test="$SensorID = @location">
						<xsl:value-of select="@id"/>
						<xsl:text>;</xsl:text>
						<xsl:value-of select="@location"/>
						<xsl:text>;</xsl:text>
						<xsl:value-of select="format-number(@x + $x_offset, '#0.0000')"/>
						<xsl:text>;</xsl:text>
						<xsl:value-of select="format-number(@y + $y_offset, '#0.0000')"/>
						<xsl:text>;</xsl:text>
						<xsl:value-of select="format-number(@z + $z_offset, '#0.0000')"/>
						<xsl:text>;</xsl:text>
						<xsl:if test="string-length(string(@date)) = 6">
							<xsl:value-of select="substring(string(@date), 1, 2)"/>
							<xsl:text>.</xsl:text>
							<xsl:value-of select="substring(string(@date), 3, 2)"/>
							<xsl:text>.</xsl:text>
							<xsl:value-of select="substring(string(@date), 5, 2)"/>
						</xsl:if>
						<xsl:text>;</xsl:text>
						<xsl:if test="string-length(string(@time)) = 6">
							<xsl:value-of select="substring(string(@time), 1, 2)"/>
							<xsl:text>:</xsl:text>
							<xsl:value-of select="substring(string(@time), 3, 2)"/>
							<xsl:text>:</xsl:text>
							<xsl:value-of select="substring(string(@time), 5, 2)"/>
						</xsl:if>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:call-template name="ReadPolygons">
				<xsl:with-param name="x_offset" select="$x_offset"/>
				<xsl:with-param name="y_offset" select="$y_offset"/>
				<xsl:with-param name="z_offset" select="$z_offset"/>
				<xsl:with-param name="SensorID" select="$SensorID + 1"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<!-- Transformationsteil zum Wandel von RSXML nach MoniMetor CSV s.d. die Zeilen nach der SensorID sortiert sind und das Format kompatibel zu den Standard-CSV Format ist -->
	<xsl:template match="robostation">
		<xsl:text>Point No.;Sensor ID;Min;Max;Z;Date;Time&#13;&#10;</xsl:text>
		<xsl:for-each select="measurements">
			<xsl:for-each select="mfolder">
				<xsl:variable name="x_offset" select="sum(@x_offset)"/>
				<xsl:variable name="y_offset" select="sum(@y_offset)"/>
				<xsl:variable name="z_offset" select="sum(@z_offset)"/>

				<xsl:call-template name="ReadPolygons">
					<xsl:with-param name="x_offset" select="$x_offset"/>
					<xsl:with-param name="y_offset" select="$y_offset"/>
					<xsl:with-param name="z_offset" select="$z_offset"/>
					<xsl:with-param name="SensorID" select="1"/>
				</xsl:call-template>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
