<?xml version="1.0" encoding="ISO-8859-1" ?>
<?rscvt type="out-filter" version="1.0" name="Topcon Koordinaten (.kor)" file-ext="*.kor;" cmd-ext="kor_out" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://ww.w3.org/TR/xlink" version="1.0">
	<!-- Ausgabe-Deklarationen -->
	<xsl:output method="text" encoding="ISO-8859-1"/>
	<xsl:strip-space elements="*"/>
	<xsl:decimal-format name="european" decimal-separator="," grouping-separator="."/>
	<!-- Variablen - Deklarationen -->
	<xsl:variable name="zerostr" select="string('                                                                                                                                                                                                                                                      ')" />
	<!-- Key Definitionen -->
	<xsl:key name="GetCatWithID" match="category" use="@id"/>
	<!-- Transformationsteil zum Wandel von RSXML nach KOR -->
	<xsl:template match="robostation">
		<xsl:for-each select="measurements">
			<xsl:for-each select="mfolder">
				<xsl:variable name="x_offset" select="sum(@x_offset)"/>
				<xsl:variable name="y_offset" select="sum(@y_offset)"/>
				<xsl:variable name="z_offset" select="sum(@z_offset)"/>
				<xsl:for-each select="polygon">
					<xsl:variable name="polycatids" select="@categories"/>
					<xsl:for-each select="point">
						<!-- Punkt ID Ausgabe -->
						<xsl:value-of select="concat(substring($zerostr, 1, 15 - string-length(@id)), @id)"/>
						<!-- Punkt-Koordinate -->
						<xsl:variable name="x" select="format-number(@x + $x_offset, '#0.0000')"/>
						<xsl:variable name="y" select="format-number(@y + $y_offset, '#0.0000')"/>
						<xsl:variable name="z" select="format-number(@z + $z_offset, '#0.0000')"/>
						<xsl:value-of select="concat(substring($zerostr, 1, 15 - string-length($y)), $y)"/>
						<xsl:value-of select="concat(substring($zerostr, 1, 15 - string-length($x)), $x)"/>
						<xsl:value-of select="concat(substring($zerostr, 1, 11 - string-length($z)), $z)"/>
						<xsl:text> </xsl:text>
						<xsl:variable name="pointcatids" select="@categories"/>
						<!-- Kategorie -->
						<xsl:choose>
							<xsl:when test="string-length($polycatids) &gt; 0">
								<xsl:choose>
									<xsl:when test="contains($polycatids, ' ')">
										<xsl:variable name="catid" select="substring-before($polycatids, ' ')"/>
										<xsl:for-each select="/robostation/category_ref">
											<xsl:for-each select="key('GetCatWithID', $catid)">
												<xsl:value-of select="@name"/>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:when>
									<xsl:otherwise>
										<xsl:for-each select="/robostation/category_ref">
											<xsl:for-each select="key('GetCatWithID', $polycatids)">
												<xsl:value-of select="@name"/>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="contains($pointcatids, ' ')">
										<xsl:variable name="catid" select="substring-before($pointcatids, ' ')"/>
										<xsl:for-each select="/robostation/category_ref">
											<xsl:for-each select="key('GetCatWithID', $catid)">
												<xsl:value-of select="@name"/>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:when>
									<xsl:otherwise>
										<xsl:for-each select="/robostation/category_ref">
											<xsl:for-each select="key('GetCatWithID', $pointcatids)">
												<xsl:value-of select="@name"/>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
						<!-- Polygon Information + (verbindung von Punkten zu Polygonen) -->
						<xsl:if test="last() &gt; 1">
							<xsl:if test="position() != last()">
								<xsl:text>+</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
